require 'ruby-hackernews'
require 'spec_helper'

require 'rhn/util'


describe "Hackernews", "#hotpage" do
  it "It should return the list of posts on the hot page" do
    # Given that we mock some posts
    RubyHackernews::Entry.should_receive(:all).and_return [
      mock_entry("1", "My post", "http://blog.c.o/p/1", 223, 12345, "clarete"),
      mock_entry("2", "Another post", "http://blog.c.o/p/22", 239, 3433, "guerrinha")]

    # When we request the hotpage posts
    desc = encode_req({:symbol => 'HN.hotpage'})
    get "/api/?r=#{desc}"

    # Then I see that I got all the entries available
    JSON.parse(last_response.body, :symbolize_names => true).should be_eql(
      {:result => [
        {:id => 1,
         :title => "My post",
         :link => "http://blog.c.o/p/1",
         :comments_count => 223,
         :voting => 12345,
         :user => "clarete"},
        {:id => 2,
         :title => "Another post",
         :link => "http://blog.c.o/p/22",
         :comments_count => 239,
         :voting => 3433,
         :user => "guerrinha"}
      ]}
    )
  end
end
